#ifndef H_MUSEDEF

#define H_MUSEDEF

#if XVT_CC == XVT_CC_THINK
#define _H_MUSEDEF
#endif

#if 0
#ifndef INCL_XVTH
#include "xvt.h"
#endif
#endif

#include "noxvt.h"
#if 0
#include "units.h"
#include "unitsmap.h"
#endif

#ifndef H_VIEW_DEF
#include "viewdef.h"
#endif

/*
 * @#Defines
 */


#if 0 /*XVT_OS == XVT_OS_WIN*/
#define MUSE_API ERRSTATUS FAR _export
#else
 typedef short MUSE_API ;
#endif



/***************************************************************
@    H_MUSEDEF
****************************************************************
H_MUSEDEF is defined to prevent multiple inclusions.

*/

/*
 * @#Defines
 */
/***************************************************************
@    SZ_*
****************************************************************
SZ_* is size of structure "*" in the map data file.

*/
#define SZ_PRODUCTS 3072	/* 2092 */
#define SZ_GRAT_DATA 512
#define SZ_BASEMAP 512
#define SZ_RASTER 1024		/* 216 required */
#define SZ_UNITS 512
#define SZ_MGM 512
#define SZ_PALETTE 2048 /*needed 9/92 1690*/	/* too short 1552 */
#define SZ_LUT /*1396*/ 2048
#define SZ_MAP_DOC 512
#define SZ_VECTOR 512
#define SZ_VEC_DATA 256


/***************************************************************
@    BASEMAPS_AVAIL_MAX
****************************************************************

*/
#define BASEMAPS_AVAIL_MAX 10L

/*
 * Description: Used to dimension the array containing the list of available
 * basemap products.
 */

/***************************************************************
@    BITS_PER_BYTE
****************************************************************
All supported systems have an 8 bit byte.
*/
#define BITS_PER_BYTE 8L

/*
 * Description:
 * 
 */

/***************************************************************
@    DivBy
****************************************************************
A set of bit shifting divide macros
*/
#define DivBy2(i)      ( (i) >>  1 )
#define DivBy4(i)      ( (i) >>  2 )
#define DivBy8(i)      ( (i) >>  3 )

/*
 * Description:
 * 
 */

/***************************************************************
@    Flip
****************************************************************
Byte fliping macros
*/
#define Flip(a)        ( sizeof(a) == 4 ? Flip4(a) : Flip2(a) )

#define Flip2(a)       ( ( ( (a) & 0x0000FF ) <<  8 ) | \
                         ( ( (a) & 0x00FF00 ) >>  8 )      )

#define Flip4(a)       ( ( ( (a) & 0x000000FF ) << 24 ) | \
                         ( ( (a) & 0x0000FF00 ) <<  8 ) | \
                         ( ( (a) & 0x00FF0000 ) >>  8 ) | \
                         ( ( (a) & 0xFF000000 ) >> 24 )      )

/*
 * Description: These macros are used by the "Endian" functions that
 * rearrange the bytes to allow integer data written on Motorola style
 * computers to be read on Intel style computers, and vice versa.
 */

/***************************************************************
@    ERROR CODES
****************************************************************
Error code values
*/

/*
 * Error Code Masks
 */

#define STAT_MASK_SEV       0xE000
#define STAT_MASK_GRP       0x1F00
#define STAT_MASK_COD       0x00FF

/*
 * Severity Codes
 */

#define STAT_SEV_NO_ERR     0x0000
#define STAT_SEV_MESSAGE    0x2000
#define STAT_SEV_WARNING    0x4000
#define STAT_SEV_ERROR      0x6000
#define STAT_SEV_FATAL      0x8000
#define STAT_SEV_CRITICAL   0xA000

/*
 * Group Codes
 */

#define STAT_GRP_NO_ERR     0x0000
#define STAT_GRP_SYSTEM     0x0100
#define STAT_GRP_FILE       0x0200
#define STAT_GRP_MATH       0x0300
#define STAT_GRP_DATA       0x0400
#define STAT_GRP_PARAM      0x0500

/*
 * No Error Group Error Codes
 */
#define STAT_SUCCESS        ( STAT_GRP_NO_ERR   | \
                   STAT_SEV_NO_ERR   | \
                   0x0000                 )
/* Error allocating memory */

/*
 * System Group Error Codes
 */

#define STAT_MEM_ALLOC_ERR  ( STAT_GRP_SYSTEM   | \
                   STAT_SEV_CRITICAL | \
                   0x0001                 )
/* Error allocating memory */
#define STAT_OS_ERROR       ( STAT_GRP_SYSTEM   | \
                   STAT_SEV_CRITICAL | \
                   0x0002                 )
/* An unknown operating system error */
#define STAT_SOFTWARE_BUG   ( STAT_GRP_SYSTEM   | \
                   STAT_SEV_CRITICAL | \
                   0x0003                 )
/* A possible bug in the software was found */
/* Abort condition */
#define STAT_ABORT          ( STAT_GRP_SYSTEM | \
                   STAT_SEV_MESSAGE | \
                   0x0004)

/*
 * File Group Error Codes
 */

#define STAT_FILE_CREAT_ERR ( STAT_GRP_FILE     | \
                   STAT_SEV_ERROR    | \
                   0x0001                 )
/* Unable to create file */
#define STAT_FILE_CLOSE_ERR ( STAT_GRP_FILE     | \
                   STAT_SEV_ERROR    | \
                   0x0002                 )
/* Unable to close file */
#define STAT_FILE_NOT_FOUND ( STAT_GRP_FILE     | \
                   STAT_SEV_ERROR    | \
                   0x0003                 )
/* Could not open file */
#define STAT_FILE_READ_ERR  ( STAT_GRP_FILE     | \
                   STAT_SEV_ERROR    | \
                   0x0004                 )
/* Error reading from file */
#define STAT_FILE_TYPE_ERR  ( STAT_GRP_FILE     | \
                   STAT_SEV_ERROR    | \
                   0x0005                 )
/* The specified file is of the wrong type */
#define STAT_FILE_WRITE_ERR ( STAT_GRP_FILE     | \
                   STAT_SEV_ERROR    | \
                   0x0006                 )
/* Error writing to a file */

/*
 * Math Group Error Codes
 */

#define STAT_DIV_BY_ZERO    ( STAT_GRP_MATH     | \
                   STAT_SEV_ERROR    | \
                   0x0001                 )
/* Attempt to divide by zero */

/*
 * Data Group Error Codes
 */

#define STAT_DATA_ERR       ( STAT_GRP_DATA     | \
                   STAT_SEV_FATAL    | \
                   0x0001                 )
/* Data index or corrupt data error */
#define STAT_NO_DATA        ( STAT_GRP_DATA     | \
                   STAT_SEV_WARNING  | \
                   0x0002                 )
/* No data for given location */

/*
 * Parameter Group Error Codes
 */

#define STAT_INV_PROJ       ( STAT_GRP_PARAM    | \
                   STAT_SEV_FATAL    | \
                   0x0001                 )
/* Invalid projection */
#define STAT_BAD_PARM       (                       \
                STAT_GRP_PARAM    | \
                STAT_SEV_ERROR    | \
                0x0002               \
                 )
#define STAT_PARM_OVERFLOW  (                    \
                STAT_GRP_PARAM | \
                STAT_SEV_ERROR | \
                0x0003            \
                 )
#define STAT_BAD_CLR_NAME   ( STAT_GRP_PARAM    | \
                STAT_SEV_FATAL    | \
                0x0004                 )
/* Unknown color name */

/*
 * Description: All MUSE functions return an error status code. The status
 * code STAT_SUCCESS is zero so a boolean test map be performed. The function
 * muse_error() can be called to handle the error code.
 */

/***************************************************************
@    FILE_CREATOR
****************************************************************
Associates data exchange files with FUSION program
*/
#define FILE_CREATOR "MUSE"

/*
 * Description: The data extractor programs should call the XVT function
 * xvt_fsys_set_file_attr() to set the extracted file's creator to this value.
 */

/***************************************************************
@    GetErr
****************************************************************
*/
#define GerErrCode(status)      (status & STAT_MASK_COD)
#define GetErrGroup(status)     (status & STAT_MASK_GRP)
#define GetErrSeverity(status)  (status & STAT_MASK_SEV)

/*
 * Description:
 */


/* SR 10/02 */
/***************************************************************
@    Grat_Data bit flag masks
****************************************************************
*/
#define GRAT_VALID_MASK              0x0001
#define GRAT_NEEDS_REDRAW_MASK       0x0002

/*
 * Description: GRAT_DATA contains a long variable "bit_flags" whose bits can
 * be set to show the current status of the structure.  Currently, bit 0 is
 * set to show the structure contains valid data, and bit 1 is set if the
 * grat overlay needs to be redrawn.
 */

/***************************************************************
@    Icons
****************************************************************
Icon ID assignments
*/

#ifndef DELETE_ICON		/* CUT_ICON      */
#define DELETE_ICON 16
#endif

#ifndef FILES_ICON		/* TEXT_ICON     */
#define FILES_ICON 13
#endif

#ifndef POINTER_ICON		/* DISTANCE_ICON */
#define POINTER_ICON 15
#endif

#ifndef TEXT_ICON		/* ZOOM_ICON     */
#define TEXT_ICON 14
#endif

/*
 * Description: used by FUSW501 to draw the icons on Tools window
 */

/***************************************************************
@    Magic Numbers
****************************************************************
Record structure type and version
*/
#define MAGIC_MGM       10000000L
#define MAGIC_UNITS     20000000L
#define MAGIC_LUT       30000000L
#define MAGIC_PALETTE   40000000L
#define MAGIC_PRODUCTS  50000001L
#define MAGIC_VIEW      60000000L
#define MAGIC_BASEMAP   70000000L
#define MAGIC_RASTER    80000000L
#define MAGIC_MAP_DOC   90080892L
#define MAGIC_DEFAULTS 100000000L
#define MAGIC_VECTOR   110000000L
/* SR 10/02 */
#define MAGIC_VEC_DATA  120000001L
#define MAGIC_GRAT_DATA 130000001L

/*
 * Description: These magic numbers are placed into the first 4 bytes of
 * their respective structures to give the programmer an easy way to verify
 * that a structure is valid. They may also be used as structure version
 * identifiers for structures saved in files.
 */

/***************************************************************
@    MAX_COLORS
****************************************************************
Miximum number of colors allowed
*/
#define MAX_COLORS 256

/*
 * Description:
 */

/***************************************************************
@    MAX_LUT
****************************************************************
Number of look-up-table ranges
*/
#define MAX_LUT 6

/*
 * Description:
 */

/***************************************************************
@    MAX_MAP_WINDOWS
****************************************************************
Limits number of open maps
*/
#define MAX_MAP_WINDOWS 10

/*
 * Description: MAX_MAP_WINDOWS determines the number of map document windows
 * that can be open at any one time, however his does not guarantee that the
 * system will have enough memory to support this many.
 */

/***************************************************************
@    MAX_PRODUCTS
****************************************************************
Limits the number of open data products
*/
#define MAX_PRODUCTS 10

/*
 * Description:
 */

/***************************************************************
@    pHMEM_NULL
****************************************************************
*/
#if 0
#define pHMEM_NULL ((pvHMEM) 0L)
typedef void pHMEM pvHMEM;
#endif
/*
 * Description:
 */

/*
 * @    Multiples of Pi
 */
#define PXPI                  3.14159265358979323846
#define PX2_PI                6.28318530717958647693
#define PXPI_OVER_2           1.57079632679489661923
#define PXDEGREES_TO_RADIANS  0.0174532925199432957692

/*
 * Description:
 */

/***************************************************************
@    NULL
****************************************************************
A long 0
#ifndef NULL
#define NULL 0L
#endif
/*
Description:
*/

/* SR 10/09 */
/***************************************************************
@    PRODUCTS bit flag masks
****************************************************************
*/
#define OVERLAYS_NEED_REDRAW_MASK       0x0002

/*
 * Description:
 */

/***************************************************************
@    RGB_BITS
****************************************************************
The default number of bits used to store RGB color values
*/
#define RGB_BITS 16

/*
 * Description: RGB values usually are stored as 16 bit unsigned shorts: (0 -
 * 65545).
 */

/***************************************************************
@    RGB_MAX
****************************************************************
The maximum value used to store RGB.
*/
#define RGB_MAX 65535L

/*
 * Description: RGB values are stored as 16 bit unsigned shorts: (0 - 65545).
 */

/***************************************************************
@    Sign
****************************************************************
*/
#define Sign(x)        ( (x) < 0.0 ? -1 : 1 )

/*
 * Description:
 */

/***************************************************************
@    STRUCTURE ID'S
****************************************************************
*/
#define BASEMAP_STRUCT 1
#define GRAT_STRUCT   2

/*
 * Description:
 */

/***************************************************************
@    TOTAL_OVERLAYS
****************************************************************
Limit on number of overlays
*/
#define TOTAL_OVERLAYS 8

/*
 * Description:
 */

/***************************************************************
@    __V_HDR__
****************************************************************
A vector data header structure
*/

#ifndef __V_HDR__
#define __V_HDR__
#define DATA_HDR_EXTENT (X) ((X)->extent)
#define DATA_HDR_LEFT    (x) EXTENT_LEFT  (DATA_HDR_EXTENT(x))
#define DATA_HDR_RIGHT    (x) EXTENT_RIGHT (DATA_HDR_EXTENT(x))
#define DATA_HDR_TOP    (x) EXTENT_TOP     (DATA_HDR_EXTENT(x))
#define DATA_HDR_BOTTOM (x) EXTENT_BOTTOM(DATA_HDR_EXTENT(x))

#define EXTENT_LEFT (x)    ((x)->left)
#define EXTENT_RIGHT (x)   ((x)->right)
#define EXTENT_BOTTOM (x)  ((x)->bottom)
#define EXTENT_TOP (x)       ((x)->top)

#define V_HDR_DATA_HDR (x)  ((x)->v_hdr)
#define V_HDR_TOP      (X)  DATA_HDR_TOP    (V_HDR_DATA_HDR(x))
#define V_HDR_BOTTOM   (x)  DATA_HDR_BOTTOM (V_HDR_DATA_HDR(x))
#define V_HDR_LEFT     (x)  DATA_HDR_LEFT   (V_HDR_DATA_HDR(x))
#define V_HDR_RIGHT    (x)  DATA_HDR_RIGHT  (V_HDR_DATA_HDR(x))
#endif

/*
 * Description:
 */

/***************************************************************
@    VER_NUM
****************************************************************
Current saved file revision number
*/
#define VER_NUM = 0x01;

/*
 * Description:
 */

/*
 * @Enumerated Data Types
 */

/***************************************************************
@    AREA
****************************************************************
Area is stored internally in SQ_METERS
*/
typedef enum
{
    SQ_METERS,
    SQ_FEET,
    SQ_KM,
    SQ_NM,
    SQ_SM
}
                AREA;

/*
 * Description:
 * 
 */

/***************************************************************
@    BASEMAP_TYPE
****************************************************************
Type of basemap products
*/
typedef enum
{
    BM_NONE,
    BM_SURFACE,
    BM_GEOIMAGE
}
                BASEMAP_TYPE;

/*
 * Description: DTED and DBDB5 are BM_SURFACE products. ADRG and CAC are
 * BM_GEOIMAGE products.
 */

/***************************************************************
@    COLOR_PREF
****************************************************************
Preference for reconciling lut and palette
*/
typedef enum
{
    ALL_PURPOSE,		/* Both image and terrain use 6level */
    FAVOR_IMAGE,		/* Lut is mapped to image palette */
    FAVOR_TERRAIN		/* Lut generates the palette */
}
                COLOR_PREF;

/*
 * Description: If all map windows use the ALL_PURPOSE color, the map windows
 * will all use the same 6 level palette and will not compete for the system
 * palette  The FAVOR_IMAGE setting will result in the terrain look-up-table
 * colos being mapped to the closest existing palette color.  The
 * FAVOR_TERRAIN setting will generate a new palette to match the lut.
 */

/***************************************************************
@    CONFIG_PREF
****************************************************************
Ways of configuring map geometry
*/
typedef enum
{
    CONFIG_GEO_EXTENT_AND_DEV_EXTENT,
    CONFIG_CENTER_AND_SCALE,
    CONFIG_CENTER_AND_POST_SPACING
}
                CONFIG_PREF;

/*
 * Description: The map geometry module supports these preferences when
 * mgm_setup is called.
 */

/***************************************************************
@    DATA_TYPE
****************************************************************
Type of data contained in a RASTER object
*/
typedef enum
{
    COLOR_INDIRECT,		/* color index numbers */
    COLOR_RGB,			/* rgb values */
    DATA			/* non-color data values */
}
                DATA_TYPE;

/*
 * Description: COLOR_INDIRECT rasters contain a matrix of color-map indices.
 * COLOR_RGB rasters contain an RGB true-color image. DATA rasters contain
 * data which must be rendered before being displayed.
 */


/***************************************************************
@    MARKER
****************************************************************
Marker types for PHIGS
*/
typedef enum
{
    DOT,
    PLUS,
    ASTERICK,
    CIRCLE,
    CROSS,
    SOLID_LINE,
    DASH_LINE,
    DOT_LINE
}
                MARKER;

/*
 * Description:
 */

/***************************************************************
@    NUM_TYPE
****************************************************************
Types of numbers
*/
typedef enum
{
    ONEBIT,			/* binary data (0 or 1) */
    UINT_4BIT,			/* unsigned 4 bit data (0 -> 15) */
    SINT_8BIT,			/* signed 8 bit data (-128 -> 127) */
    UINT_8BIT,			/* unsigned 8 bit data (0 -> 255) */
    SINT_16BIT,			/* signed 16 bit (-32768 -> 32767) */
    UINT_16BIT,			/* unsigned 16 bit ( 0 -> 64K) */
    DTED_16BIT,			/* Univac signed magnitude */
    RGB_24BIT,			/* RGB (0 -> 255) interleaved by pixel */
    RGB_48BIT,			/* RGB (0 -> 65535) interleaved by pixel */
    SINT_32BIT,			/* signed 32 bit */
    UINT_32BIT,			/* unsigned 32 bit */
    IEEE_32BIT,			/* same as float */
    IEEE_64BIT			/* same as double */
}
                NUM_TYPE;

/*
 * Description: These are the number types that can be stored in RASTER's.
 */

/***************************************************************
@    OVERLAY_TYPE
****************************************************************
Types of overlays
*/
typedef enum
{
    GRAT,
    VECT,
    N_C_C,
    NONE
}
                OVERLAY_TYPE;

/*
 * Description:
 * 
 */

/***************************************************************
@    PAL_TYPE
****************************************************************
Types of palettes
*/

typedef enum
{
    PAL_UNKNOWN,		/* non-algorithmic palette- use min dist */
    PAL_BIT_BINS,		/* #bits for R,G, and B */
    PAL_NUM_BINS,		/* #bins for R, G, and B */
    PAL_GREY			/* equal R, G, B */
}
                PAL_TYPE;

/*
 * Description: PAL_TYPE indicates the algorithm by which it was constructed
 * and thus how it can be used.  PAL_UNKNOWN palettes have an unknown origin.
 * Colors are classified into unknown palettes using minimum distance.
 * PAL_RGB_BINS palettes are constructed as a 3D matrix of color with red,
 * green, and blue on the three axes.  Colors may be classified into these
 * palettes using fast bit operations.
 */

/***************************************************************
@    PRODUCT
****************************************************************
Basemap products
*/
typedef enum
{
    BASE_NONE,
    BASE_ADRG,
    BASE_CAC,
    BASE_DTED,
    BASE_DBDB5,
    BASE_DATA,
    BASE_OTHER
}
                PRODUCT;

/*
 * Description:
 */


/***************************************************************
@    USER_LEVEL
****************************************************************
Levels of user experience.
*/
typedef enum
{
    NOVICE,
    EXPERIENCED,
    EXPERT
}
                USER_LEVEL;

/*
 * Description:
 */

/***************************************************************
@    VOLUME
****************************************************************
Volume is stored internally in CU_METERS
*/
typedef enum
{
    CU_METERS,
    CU_FT,
    CU_KM,
    CU_NM,
    CU_SM
}
                VOLUME;

/*
 * Description:
 */

/*
 * @Simple Data Types
 */

/*
 * @    BOOLEAN
 */

#if 0 /*ifndef INCL_XVTH*/

#ifndef BOOLEAN
typedef short   BOOLEAN;
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#endif

/*
 * Description:
 */

/*
 * @Complex Data Types
 */

/***************************************************************
@    ACCURACY
****************************************************************
*/
typedef struct
{
    GFLOAT          rel_hor;	/* relative horizontal accuracy */
    GFLOAT          abs_hor;	/* absolute horizontal accuracy */
    GFLOAT          rel_ver;	/* relative data value accuracy */
    GFLOAT          abs_ver;	/* absolute data value accuracy */
}               ACCURACY;

/*
 * Description:
 */

/***************************************************************
@    APP_DATA
****************************************************************
Stores the window handler function and application data
*/
typedef struct
{
    long            data;

#if 0 /*XVT_CC_PROTO*/
    void            (*handler) (WINDOW win, EVENT * ep);
#else				/* !PROTO */
    void            (*handler) ();
#endif
}               APP_DATA;

/*
 * Description: See XVT's APP_DATA
 */

/***************************************************************
@    MGM_LIST
****************************************************************
A list of the available projections
*/
typedef struct
{
    short           count;
    char            list[15][30];
}               MGM_LIST;

/*
 * Description:
 */

/***************************************************************
@    BUTTON
****************************************************************
Structure to contain a button description
*/
typedef struct
{
    short           x;
    short           y;
    char            string[50];
  /*    RCT             rct;*/
}               BUTTON;

/*
 * Description: XVT R2 did not support use of buttons in windows, so we did.
 */

/***************************************************************
@    BUTTONS_LIST
****************************************************************
A list of buttons
*/
typedef struct
{
    short           count;
    BUTTON          list[20];
}               BUTTONS_LIST;

/*
 * Description:
 */

/***************************************************************
@    WINDOW_INFO
****************************************************************
Information about a control window.
*/
typedef struct
{
    WINDOW          win;	/* the window identifier or NULL  */
    BOOLEAN         enabled;	/* TRUE if the window can receive events */
    BOOLEAN         phigs_ready;/* TRUE if ready for PHIGS update */
  /*    RCT             rct;	/* the initial rectangle */
}               WINDOW_INFO;

/*
 * Description: The WINDOW_INFO structure is used to contain the status of
 * the control windows.  The enabled member is true, the the window will
 * ignore any events that it receives.  This is used during map update to
 * disable selected control windows.
 */

/***************************************************************
@    WINDOWS
****************************************************************
List of open map windows and status of all static windows.
*/
typedef struct
{
    WINDOW          list[10];
    WINDOW          current_map;
    WINDOW_INFO     tools;
    WINDOW_INFO     palette;
    WINDOW_INFO     geometry;
    WINDOW_INFO     map_data;
    WINDOW_INFO     cursor;
    WINDOW_INFO     lut;
    WINDOW_INFO     status;
    void           *current_mapdoc;
}               WINDOWS;

/*
 * Description:
 */

/***************************************************************
@    SCROLL_STUFF
****************************************************************
Info about a basemap product
*/

typedef struct
{
        BOOLEAN         scaled;
        PNT             org;	/* app coord. at upper left of client area */
        PNT             range;  /* actual range (app coordinates) */
#if 0
        FONT /* XVT_FNTID xvt_R3FNT */             font;
#endif
}       SCROLL_STUFF;

/*
 *      Description:
 */

/***************************************************************
@    BASEMAP_PRODUCT
****************************************************************
Info about a basemap product
*/
typedef struct
{
    char            name[30];
    BASEMAP_TYPE    type;
    char            prompt[48];
    BOOLEAN         warpable;
    FILE_SPEC       file_spec;
}               BASEMAP_PRODUCT;

/*
 * Description:
 */

/***************************************************************
@    BASEMAP_LIST
****************************************************************
List of supported basemap data products
*/
typedef struct
{
    short           count;
    BASEMAP_PRODUCT list[BASEMAPS_AVAIL_MAX];
}               BASEMAP_LIST;

/*
 * Description:
 */

/***************************************************************
@    OVERLAY_LIST
****************************************************************
List of overlays to be displayed
*/
typedef struct
{
    short           count;
    char            list[10][30];
}               OVERLAY_LIST;

/*
 * Description:
 */

/***************************************************************
@    PRODUCTS_LIST
****************************************************************
List of data to be displayed
*/
typedef struct
{
    BASEMAP_LIST    basemaps;
    OVERLAY_LIST    overlays;
}               PRODUCTS_LIST;

/*
 * Description:
 */

/***************************************************************
@    RGB24
****************************************************************
Structure to contain 24 bit RGB pixel
*/
typedef struct
{
    BYTE            r;
    BYTE            g;
    BYTE            b;
}               RGB24;

/*
 * Description:
 */

/***************************************************************
@    RGB
****************************************************************
Structure to contain 48 bit RGB data
*/
typedef struct
{
    unsigned short  r;
    unsigned short  g;
    unsigned short  b;
}               RGB;

/*
 * Description:
 */

/***************************************************************
@    PALETTE
****************************************************************
Structure for a color palette
*/
typedef struct
{
    long            magic;	/* structure id */
    PAL_TYPE        type;	/* how it was generated and used */
    RGB             bins;	/* # bins if type is PAL_RGB_BINS */
    USHORT          first_color;/* index of first valid palette color */
    USHORT          num_colors;	/* # of valid colors */
    RGB             rgb[MAX_COLORS];	/* RGBs range 0 - 65535 (16bit) */
    FILE_SPEC       palette_file;	/* where it is stored */
}               PALETTE;

/*
 * Description: These objects may be created and read using
 * palette_construct(). They may be destroyed and written using
 * palette-destruct().
 */

/***************************************************************
@    EXTENT
****************************************************************
The bounds of something
*/
typedef struct
{
    GFLOAT          left;	/* Leftmost extent of the dataset in DD   */
    GFLOAT          right;	/* Rightmost extent of the dataset in DD  */
    GFLOAT          bottom;	/* Bottommost extent of the dataset in DD */
    GFLOAT          top;	/* Topmost extent of the dataset in DD    */
}               EXTENT;

/*
 * Description:
 */

/***************************************************************
@    DATE
****************************************************************
Date structure
*/
typedef struct
{
    char            year[3];
    char            month[3];
    char            day[3];
    char            hour[3];
    char            minute[3];
    char            second[3];
}               DATE;

/*
 * Description:
 */
#if 0
typedef enum
{
    /*DD,*/DDTEMP,
    DMS,
    /*GEOREF,*/
    MGRS,
    MIN,
    SECS,
    UTM
} GEOGRAPHIC;

/***************************************************************
@    PROJECTION
****************************************************************
Map projections
*/
typedef enum
{
    PROJ_UNDEFINED,
    PROJ_LAMBERT1,
    PROJ_LAMBERT2,
    PROJ_LINEAR,
    PROJ_MERCATOR,
    PROJ_UPS,
    PROJ_UTM,
    PROJ_GRAPH,
    PROJ_POLAR,
    PROJ_ARC,
    PROJ_TS
} PROJECTION;
#endif
/*
 * Projections to be added in the future: PROJ_BONNE, PROJ_MOLLWEIDE,
 * PROJ_ORTHOGRAPHIC, PROJ_STEREOGRAPHIC, PROJ_TRANSVERSE_MERCATOR,
 * 
 * Description:
 */

/***************************************************************
@    DATA_HDR STRUCTURE
****************************************************************
A header structure for all extracted data
*/
typedef struct
{
    char            source[30];	/* Source of the data                  */
    GEOGRAPHIC      h_units;	/* Horizonal units of measurement      */
    VER_DISTANCE    v_units;	/* Vertical units of measurement       */
    GFLOAT          x_res;	/* X resoultion of the data in h_units */
    GFLOAT          y_res;	/* Y Resolution of the data in h_units */
    PROJECTION      projection;	/* Projection name of the data         */
    POINT_DD          center;	/* Center of the data in geographics   */
    EXTENT          extent;	/* Bounding geocoordinates of the data */
    DATUM           datum;	/* Horizonal and vertical datum        */
    ACCURACY        accuracy;	/* Accuricy of the data                */
    DATE            date;	/* Date the data was created/extracted */
    GFLOAT          zoom;	/* 0->1 for downsampling, >1 for
				 * interpolation */
    GFLOAT          data_min;	/* minimum data value */
    GFLOAT          data_max;	/* maximum data value */
}               DATA_HDR;

/*
 * Description:
 */

/***************************************************************
@    DATA_MATRIX
****************************************************************
A structure for matrix data
*/
typedef struct
{
    long            width;	/* Num of columns */
    long            height;	/* Num of rows */
    long            bits_per_pixel;	/* Num bits for each matrix value */
    long            bytes_per_row;	/* All rows must be word(16 bit)
					 * alligned */
    NUM_TYPE        num_type;	/* Numeric type and size */
    DATA_TYPE       data_type;	/* Data or color type */
    GHANDLE         ghandle;	/* Global handle defined by XVT */
}               DATA_MATRIX;

/*
 * Description: To allow portable big arrays, the global heap is used. See
 * the XVT User's Guide, Chap 15, Memory Allocation. If you are not using XVT
 * you may need to redefine GHANDLE to void *.
 */

/*
 * Description:
 */

/***************************************************************
@    UNITS
****************************************************************
Structure to contain the users units selections
*/
typedef struct
{
    long            magic;
    SCALE           scale;
    HOR_DISTANCE    hor_distance;
    VER_DISTANCE    ver_distance;
    AREA            area;
    VOLUME          volume;
    GEOGRAPHIC      geographic;
}               UNITS;


/***************************************************************
@    DEFAULTS
****************************************************************
The structure of program defaults
*/
typedef struct
{
    long            magic;	/* magic number to id structure */
    DATA_MATRIX     bitmap_matrix;	/* default bit_map size and type */
    GFLOAT          center_lon;	/* default map center, DD */
    GFLOAT          center_lat;	/* default map center, DD */
    COLOR_PREF      color_pref;	/* default color_pref */
    USER_LEVEL      user_level;	/* NOVICE, EXPERIENCED, EXPERT */
    char            map_file_dir[SZ_FNAME];	/* default map directory SR */
    BOOLEAN         needs_save;	/* true if needs to be saved */
    BOOLEAN         auto_update;/* if FALSE, the user has to push the Update
				 * Map button */
    UNITS           units;	/* user units */
    FILE_SPEC       map_file_spec;	/* default map file */
    FILE_SPEC       def_file_spec;	/* where the defaults file is stored */
}               DEFAULTS;

/*
 * Description:
 */

/***************************************************************
@    AVAILABLE
****************************************************************
The structure defining program capabilities
*/
typedef struct
{
    MGM_LIST       *mgm;	/* list of projections */
    UNITS_LIST     *units;	/* list of units */
    BUTTONS_LIST   *buttons;	/* list of buttons */
    WINDOWS        *windows;	/* list of windows */
    PRODUCTS_LIST  *products_list;	/* list of products */
    PALETTE        *palette;	/* default palette */
    DEFAULTS       *defaults;	/* other defaults */
    FILE_SPEC       help_file_spec;	/* location of the help file */
    SCROLL_STUFF    scroll_stuff[MAX_MAP_WINDOWS];
}               AVAILABLE;

/*
 * Description:
 */

/***************************************************************
@    SHADE
****************************************************************
A structure containing a color saturation and value
*/
typedef struct
{
    GFLOAT          sat;	/* 0.0 - 1.0 range */
    GFLOAT          val;	/* 0.0 - 1.0 range */
}               SHADE;

/*
 * Description:
 */

/***************************************************************
@    LUT_DESC
****************************************************************
A look-up-table descriptor
*/
typedef struct
{
    long            num_hues;	/* number of color bands */
    long            num_shades;	/* number of shades of each color */
    GFLOAT          data_range[2];
    GFLOAT          hue_range[2];
    SHADE           shade_range[3];
}               LUT_DESC;

/*
 * Description:
 */

/***************************************************************
@    LUT
****************************************************************
A look-up-table
*/
typedef struct
{
    long            magic;	/* LUT version id */
    LUT_DESC        lut_desc[MAX_LUT];	/* The lut descriptors */
    USHORT          map[MAX_COLORS];	/* map to nearest pal color */
    BOOLEAN         stretch;   /* Fit Colors to LUT range */
    FILE_SPEC       lut_file;	/* File name */
}               LUT;

/*
 * Description: Each LUT_DESCriptor defines the data, hue, saturation, and
 * value ranges for a data range.  Lut2pal() generates a palette from a lut.
 * Lut_lookup() looks a data value up in the lut to determine its color.
 */

/***************************************************************
@    RASTER
****************************************************************
Contains a grid of image or other data
*/
typedef struct
{
    long            magic;
    DATA_HDR        data_hdr;
    DATA_MATRIX     data_matrix;
    LUT            *lut;	/* NULL unless data_type is DATA */
    PALETTE        *palette;	/* NULL unless data_type is COLOR_INDIRECT */
}               RASTER;

/*
 * Description: The functions raster_construct() ans raster_destruct are used
 * to create and destroy these, as well as read and write them from files.
 */

/***************************************************************
@    RENDER_INFO
****************************************************************
Info to render a DATA raster into a COLOR_INDIRECT raster
*/
typedef struct
{
    GFLOAT          shade_threshold;
    GFLOAT          precision;
    long            sunx;
    long            suny;
}               RENDER_INFO;

/*
 * Description: The shade_threshold is the data differencebetween the data
 * value and the one located at relative position sunx, suny within the data
 * raster that is needed to move the color a shade lighter or darker
 * (depending on sign).  The precision can be increased to make the rendering
 * faster.  If the the previous data value and delta are within precision of
 * the last data value and delta, the last color is used.
 */

/***************************************************************
@    BASEMAP
****************************************************************
Struct to contain the basemap information
*/
typedef struct BASEMAP
{
    long            magic;
    PRODUCT         product;	/* which product */
    RASTER         *area;	/* product dependent */
    RASTER         *bit_map;	/* plotable image */
    RENDER_INFO     render_info;/* NULL unless its a DATA product */
    GFLOAT          zoom;	/* 0.0<zoom<1.0=downsampling,
				 * zoom>1.0=replication */
    BOOLEAN         needs_refresh;	/* true if needs any work */
    BOOLEAN         needs_redraw;	/* true if it needs redrawing */
    BOOLEAN         needs_reload;	/* true if it needs to be reloaded */
    BOOLEAN         warp;	/* true ifit supports projection warp */
    FILE_SPEC       file_spec;	/* where in the file system */
}               BASEMAP;
/*
 * Description:
 */


/***************************************************************
@    GRAT_DATA
****************************************************************
Structure to define a graticule
*/
typedef struct
{
    long            color;
    long            magic;	/* SR 10/02 */
    long            bit_flags;
    BOOLEAN         contains_valid_data;
    BOOLEAN         border_enable;
    BOOLEAN         border_major_enable;
    GFLOAT          border_major_lat;
    GEOGRAPHIC      border_major_lat_unit;
    GFLOAT          border_major_lon;
    GEOGRAPHIC      border_major_lon_unit;
    long            border_major_color;

    BOOLEAN         border_minor_enable;
    GFLOAT          border_minor_lat;
    GEOGRAPHIC      border_minor_lat_unit;
    GFLOAT          border_minor_lon;
    GEOGRAPHIC      border_minor_lon_unit;
    long            border_minor_color;

    BOOLEAN         border_labels_enable;
    GFLOAT          border_labels_lat;
    GEOGRAPHIC      border_labels_lat_unit;
    GFLOAT          border_labels_lon;
    GEOGRAPHIC      border_labels_lon_unit;
    long            border_labels_color;

    BOOLEAN         grat_enable;
    BOOLEAN         grat_major_enable;
    MARKER          grat_major;
    BYTE            grat_major_ascii_code;
    GFLOAT          grat_major_lat;
    GEOGRAPHIC      grat_major_lat_unit;
    GFLOAT          grat_major_lon;
    GEOGRAPHIC      grat_major_lon_unit;
    long            grat_major_color;

    BOOLEAN         grat_minor_enable;
    MARKER          grat_minor;
    BYTE            grat_minor_ascii_code;
    GFLOAT          grat_minor_lat;
    GEOGRAPHIC      grat_minor_lat_unit;
    GFLOAT          grat_minor_lon;
    GEOGRAPHIC      grat_minor_lon_unit;
    long            grat_minor_color;
}               GRAT_DATA;

/*
 * Description:
 */

/***************************************************************
@    MGM
****************************************************************
The map geometry structure
*/
typedef struct MGM
{
    long            magic;
    PROJECTION      projection;	/* the objects projection */
    HOR_DATUM       hor_datum;	/* an enum type */
    VER_DATUM       ver_datum;	/* an enum type */

    CONFIG_PREF     config_pref;/* how to resolve inconsistent params */
    POINT_DD          map_center;	/* geocoord of map center, DD */
    GFLOAT          scale_reciprocal;	/* 250000 for scale of 1:250,000 */
    GFLOAT          pixel_size_on_screen;	/* meters */
    GFLOAT          pixel_size_on_ground;	/* meters */
    GFLOAT          pixel_size_lon;	/* size in decimal degrees */
    GFLOAT          pixel_size_lat;	/* size in decimal degrees */
    EXTENT          dev_extent;	/* bounding device rectangle */
    GFLOAT          dev_ymin;	/* smallest y on map */
    GFLOAT          dev_ymax;	/* largest y on map */
    long            xpixels;	/* width in pixels */
    long            ypixels;	/* height in pixels */
    long            bit_map_depth;	/* bits per pixel 1, 4, 8, or 24 */
    EXTENT          geo_extent;	/* bounding geographic rectangle, DD */
    GFLOAT          pixasp;	/* aspect ratio of pixel, (Y/X) */
    GFLOAT          horizontal_accuracy;	/* of most inaccurate
						 * product, meters */
    GFLOAT          vertical_accuracy;	/* of most inaccurate product, meters */
    BOOLEAN         user_aspect;/* If true user aspect used, else default */
    ASPECT          aspect;	/* aspect of projection */
    PARAMS          params;	/* projection dependent params */
    BOOLEAN         valid;	/* FALSE indicates an invalid projection
				 * object */

    GFLOAT          sx;		/* empirical x scale */
    GFLOAT          sy;		/* empirical y scale */
    GFLOAT          tx;		/* empirical x shift */
    GFLOAT          ty;		/* empirical y shift */
    BOOLEAN         is_locked;	/* true when locked to basemap */
}               MGM;

/*
 * Description: The sx,sy, tx, ty items fit the projection space to the
 * bitmap space.
 */


/***************************************************************
@    OVERLAYS
****************************************************************
The list of overlays
*/
typedef struct
{
    OVERLAY_TYPE    type;
    char            name[64];
    void           *product_pointer;
    /* FILE_SPEC file_spec; */
    /* VEC_DATA vec_data; *//* 09/92--product pointer now points to this */
}               OVERLAYS;

/*
 * Description:
 */


/***************************************************************
@    PRODUCTS
****************************************************************
The list of products
*/
typedef struct
{
    long            magic;
    long            bit_flags;	/* SR 10/09 */
    short           count;
    short           order;
    OVERLAYS        overlays[MAX_PRODUCTS];
    BASEMAP        *basemap;
}               PRODUCTS;

/*
 * Description:
 */


/***************************************************************
@    MAPDOC
****************************************************************
The map document structure
*/
typedef struct
{
    long            magic;	/* for programmer's sanity check */
    MGM            *mgm;	/* the map geometry */
    UNITS          *units;	/* the selected display units */
    LUT            *lut;	/* the look-up-table */
    PALETTE        *palette;	/* the palette */
    PRODUCTS       *products;	/* the list of products displayed */
    VIEW           *view;	/* the viewing parameters, scrool, zoom */
    /* items below here are not written into the map files */
    BOOLEAN         xvt_dwin_is_update_needed;	/* TRUE if display is not current */
    BOOLEAN         needs_save;	/* TRUE if file is not current */
    BOOLEAN         auto_update;/* TRUE for automatic map updates */
    FILE_SPEC       file_spec;	/* the map document's file */
}               MAP_DOC;

/*
 * Description: Contains all the information associated with a map document.
 * mapdoc_construct() and mapdoc_destruct() are used to create and destroy
 * and also to read and write.
 */

/***************************************************************
@    MATRIX
****************************************************************
A data matrix of any kind
*/
typedef struct
{
    long            width;	/* of data matrix                        */
    long            height;	/* of data matrix                        */
    GHANDLE         gh;
    short pHMEM     data;	/* Row major, bottom to top (short data) */
}               MATRIX;

/*
 * Description: A major component of the RASTER structure
 */


/***************************************************************
@    TEXT
****************************************************************
A text structure
*/
typedef struct
{
    unsigned long   length;
    char           *string;
}               TEXT;

/*
 * Description: These are returned by the product meta-data constructors.
 */

#endif				/* ifndef H_MUSEDEF */
