#ifndef H_MUSEPLAT
#define H_MUSEPLAT

#if XVT_CC == XVT_CC_THINK
#define _H_MUSEPLAT
#endif

#if 0
#ifndef INCL_XVTH
#include "xvt.h"		/* to define the conditional compilation
				 * constants */
#endif				/* INCL_XVTH */
#endif
#include "noxvt.h"

/****************************************************************/
/* THINK C for the Macintosh II running MAC OS          */
/****************************************************************/

#if defined(OS_MAC)
/* Standard THINK C libraries */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#define DTED_EXT ".DT1;1"
#define PAL_OFFSET 0
#endif				/* if XVT_OS == XVT_OS_MAC */


/****************************************************************/
/* TURBO C for the IBM PC running MS-DOS             */
/****************************************************************/

#if defined(OS_NT)
/* Standard TURBO C header files */

#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <fcntl.h>
#include <process.h>

/* Other useful macros */
#define TRUE    1
#define FALSE   0
#define DLongSwap(a,b)

#define DTED_EXT ".DT1"
#define PAL_OFFSET 10
#endif				/* if XVT_OS == XVT_OS_NT */

/****************************************************************/
/* Sun Workstation                        */
/****************************************************************/

#if defined(OS_SUN4) || defined(OS_SUN5)
/* Standard SUN C headers */
#include <stdio.h>
#include <fcntl.h>
#include <math.h>

/* Other useful SUN macros and typedefs */
#define TRUE      1
#define FALSE     0
#define SEEK_SET  0
#define SEEK_CUR  1
#define SEEK_END  2
#define O_BINARY  0

/* typedef unsigned short size_t; */

#define DTED_EXT ".dt1"
#define PAL_OFFSET 38
#endif				/* XVT_OS_ISBSD */

/****************************************************************/
/* SGI Workstation                        */
/****************************************************************/

#if defined(OS_IRIX)
/* Standard IRIX C headers */
#include <stdio.h>
#include <fcntl.h>
#include <math.h>

/* Other useful SGI macros and typedefs */
#define TRUE      1
#define FALSE     0
#define SEEK_SET  0
#define SEEK_CUR  1
#define SEEK_END  2
#define O_BINARY  0

/* typedef unsigned short size_t; */

#define DTED_EXT ".dt1"
#define PAL_OFFSET 38
#endif	    

/****************************************************************/
/* HP Workstation                        */
/****************************************************************/

#if defined(OS_HPUX)
/* Standard HP headers */
#include <stdio.h>
#include <fcntl.h>
#include <math.h>

/* Other useful HP  macros and typedefs */
#define TRUE      1
#define FALSE     0
#define SEEK_SET  0
#define SEEK_CUR  1
#define SEEK_END  2
#define O_BINARY  0

#define DTED_EXT ".dt1"
#define PAL_OFFSET 38
#endif	

/****************************************************************/
/* SCO Workstation                        */
/****************************************************************/

#if defined(OS_SCOUNIX)
/* Standard SUN headers */
#include <stdio.h>
#include <fcntl.h>
#include <math.h>

/* Other useful SUN macros and typedefs */
#define TRUE      1
#define FALSE     0
#define SEEK_SET  0
#define SEEK_CUR  1
#define SEEK_END  2
#define O_BINARY  0
/* Other useful SUN macros and typedefs */
#define TRUE      1
#define FALSE     0
#define SEEK_SET  0
#define SEEK_CUR  1
#define SEEK_END  2
#define O_BINARY  0

#define DTED_EXT ".dt1"
#define PAL_OFFSET 38

typedef unsigned int size_t;
#endif				/* if XVT_CC_ISSYSV */

/****************************************************/
/* SPECIFY FILE TYPES                               */
/****************************************************/

#define FT_LUT			"lut"
#define FT_MAP			"map"
#define FT_PAL			"pal"
#define FT_RAS			"ras"
#define FT_RAS_ADRG		"adr"
#define FT_RAS_CAC		"cac"
#define FT_RAS_DATA		"ima"
#define FT_RAS_DBDB5	        "dbd"
#define FT_RAS_DTED		"dte"
#define	FT_UNKNOWN		"\0"

/****************************************************/
/* PROCESSOR BYTE ORDER DEPENDENCIES                */
/****************************************************/

#if defined(OS_MAC) || defined(OS_SUN4) || defined(OS_SUN5) || defined(OS_HPUX) || defined(OS_IRIX)
/* Motorola, Sparc, or other BigEndian processors */

#define BigEndianToShortArray(byteCount,shortPtr)
#define BigEndianToLongArray(byteCount,longPtr)

#if XVT_CC_PROTO
void            LittleEndianToLongArray(long byteCount, long *longPtr);
void            LittleEndianToShortArray(long byteCount, short *shortPtr);
void            SignedMagnitudeToShortArray(long byteCount, short *shortPtr);
#else
void            LittleEndianToLongArray();
void            LittleEndianToShortArray();
void            SignedMagnitudeToShortArray();
#endif

#endif				/* if XVT_OS == XVT_OS_MAC ||  XVT_OS ==

				 * XVT_OS_SUNOS */

#if defined(OS_NT) ||  defined(OS_SCOUNIX)
/* Intel, or LittleEndian processor */

#define LittleEndianToLongArray(s,d)
#define LittleEndianToShortArray(s,d)
#define BigEndianToShortArray(s, d)  swab((char *)(d), (char *)(d), (int)(s))
#define TwosComplimentToShortArray(s,d)

#if XVT_CC_PROTO
void            BigEndianToLongArray(long size, long *data);
void            SignedMagnitudeToShortArray(long size, short *data);
#else
void            BigEndianToLongArray();
void            SignedMagnitudeToShortArray();
#endif

#endif				/* if XVT_OS == XVT_OS_NT ||  XVT_OS_SCOUNIX */

#endif				/* H_MUSEPLAT */
